<?php
namespace Zray;

if (class_exists('ZRayPlugin', false)) {

	class AwsSdk {
	    public function collect($context, &$storage) {
	        $awsService = substr(strrchr(get_class($context['this']), '\\'), 1);
	        if (substr($awsService, -6, 6) === 'Client') {
	            $awsService = substr($awsService, 0, -6);
	        }
	        $storage[$awsService][] = [
	            $context['functionArgs'][0] => [
	                'arguments' => $context['functionArgs'][1],
	                'result' => $context['returnValue'],
	            ],
	        ];
	    }
	}

	$awsSdk = new AwsSdk();

	$zrp = new \ZRayPlugin("AWS\SDK", true);
	$zrp->traceFunction('Aws\AwsClient::__call', null, [$awsSdk, 'collect']);
}