<?php
namespace ZRay;

if (class_exists('ZRayPlugin', false) && function_exists('register_shutdown_function')) {

	class Constants {
	    public function collect(array $context, array &$storage) {
	        $storage['Constants'][] = get_defined_constants(true);
	        // $storage['Functions'][] = get_defined_functions(true)['user'];
	    }

	    public static function shutdown(): bool {
	        return true;
	    }
	}

	register_shutdown_function('ZRay\Constants::shutdown');

	$zrp = new \ZRayPlugin("Constants", true);

	$constants = new Constants();

	$zrp->traceFunction(
		'ZRay\Constants::shutdown',
		null,
		[$constants, 'collect']
	);
}
