<?php

/**
 * Copyright (c) 2023 Zend by Perforce
 */

namespace ZRay;

if (!class_exists('ZRayPlugin', false)) {
    return;
}

require_once 'Magento.php';

$zrp = new \ZRayPlugin("Magento", true);

$magento = new Magento();

$traces = [
    ['Magento\Config\App\Config\Type\System::loadScopeData', null, [$magento, 'scopeCollect']],
    ['Magento\Framework\App\Filesystem\DirectoryList::getDefaultConfig', null, [$magento, 'pathData']],
    ['Magento\Framework\Event\Manager::dispatch', null, [$magento, 'eventsCollect']],
    ['Magento\Framework\App\FrontController::processRequest', null, [$magento, 'frontController']],
    ['Magento\Framework\Profiler\Driver\Standard\Output\Zray::display', null, [$magento, 'profilerCollect']],
    ['Magento\Framework\App\Bootstrap::run', [$magento, 'profilerInit'], [$magento, 'mageRunExit']],
    ['Magento\Framework\App\Bootstrap::populateAutoloader', [$magento, 'magentoInit'], null],
    ['ZRay\Magento::zrayIntercept', null, [$magento, 'pluginsCollect']],
];

foreach ($traces as $trace) {
    $zrp->traceFunction($trace[0], $trace[1], $trace[2]);
}
