# MongoDB plugin

This is a plugin to add [MongoDB PHP Library](https://www.mongodb.com/docs/php-library/current/) introspection to ZendHQ's ZRay. 

### Info Tab

The `Info` tab displays debug information about MongoDB connection state.

* **version**: MongoDB lib version 
* **uri**: connection URI
* **write operations**: rows modified counts
* etc

### Query Tab

The `Query` tab displays information about all executed MongoDB commands.
Commands are converted to SQL-like readable syntax containing Json-formatted parameters.

It exposes the following columns:

* **ID**: Command sequence number
* **Time**: Time spent in milliseconds
* **Rows**: Affected or matched rows count
* **Result**: "ok" or "fail"
